package ru.dbotthepony.kstarbound.world.api

import ru.dbotthepony.kstarbound.RegistryObject
import ru.dbotthepony.kstarbound.defs.tile.LiquidDefinition
import java.io.DataInputStream

interface ILiquidState {
	var def: LiquidDefinition?
	var level: Float
	var pressure: Float
	var isInfinite: Boolean

	val isEmpty: Boolean

	fun read(
		liquidAccess: (Int) -> RegistryObject<LiquidDefinition>?,
		stream: DataInputStream
	) {
		def = liquidAccess(stream.readUnsignedByte())?.value
		level = stream.readFloat()
		pressure = stream.readFloat()
		isInfinite = stream.readBoolean()
	}

	companion object : ILiquidState {
		override var def: LiquidDefinition?
			get() = null
			set(value) { throw UnsupportedOperationException("Empty liquid state") }
		override var level: Float
			get() = 0f
			set(value) { throw UnsupportedOperationException("Empty liquid state") }
		override var pressure: Float
			get() = 0f
			set(value) { throw UnsupportedOperationException("Empty liquid state") }
		override var isInfinite: Boolean
			get() = false
			set(value) { throw UnsupportedOperationException("Empty liquid state") }
		override val isEmpty: Boolean
			get() = true
	}
}